Atomics

## Classes

struct | std::__atomic_base< _ITp >
struct | std::__atomic_base< _PTp * >
struct | std::__atomic_flag_base
struct | std::atomic< _Tp >
struct | std::atomic< _Tp * >
struct | std::atomic< bool >
struct | std::atomic< char >
struct | std::atomic< char16_t >
struct | std::atomic< char32_t >
struct | std::atomic< int >
struct | std::atomic< long >
struct | std::atomic< long long >
struct | std::atomic< short >
struct | std::atomic< signed char >
struct | std::atomic< unsigned char >
struct | std::atomic< unsigned int >
struct | std::atomic< unsigned long >
struct | std::atomic< unsigned long long >
struct | std::atomic< unsigned short >
struct | std::atomic< wchar_t >
struct | std::atomic_flag

## Macros

#define | __cpp_lib_atomic_is_always_lock_free
#define | _GLIBCXX20_INIT(I)
#define | _GLIBCXX20_INIT(I)
#define | ATOMIC_BOOL_LOCK_FREE
#define | ATOMIC_CHAR16_T_LOCK_FREE
#define | ATOMIC_CHAR32_T_LOCK_FREE
#define | ATOMIC_CHAR_LOCK_FREE
#define | ATOMIC_FLAG_INIT
#define | ATOMIC_INT_LOCK_FREE
#define | ATOMIC_LLONG_LOCK_FREE
#define | ATOMIC_LONG_LOCK_FREE
#define | ATOMIC_POINTER_LOCK_FREE
#define | ATOMIC_SHORT_LOCK_FREE
#define | ATOMIC_VAR_INIT(_VI)
#define | ATOMIC_WCHAR_T_LOCK_FREE

## Typedefs

typedef unsigned char | std::__atomic_flag_data_type
typedef atomic< bool > | std::atomic_bool
typedef atomic< char > | std::atomic_char
typedef atomic< char16_t > | std::atomic_char16_t
typedef atomic< char32_t > | std::atomic_char32_t
typedef atomic< int > | std::atomic_int
typedef atomic< int16_t > | std::atomic_int16_t
typedef atomic< int32_t > | std::atomic_int32_t
typedef atomic< int64_t > | std::atomic_int64_t
typedef atomic< int8_t > | std::atomic_int8_t
typedef atomic< int_fast16_t > | std::atomic_int_fast16_t
typedef atomic< int_fast32_t > | std::atomic_int_fast32_t
typedef atomic< int_fast64_t > | std::atomic_int_fast64_t
typedef atomic< int_fast8_t > | std::atomic_int_fast8_t
typedef atomic< int_least16_t > | std::atomic_int_least16_t
typedef atomic< int_least32_t > | std::atomic_int_least32_t
typedef atomic< int_least64_t > | std::atomic_int_least64_t
typedef atomic< int_least8_t > | std::atomic_int_least8_t
typedef atomic< intmax_t > | std::atomic_intmax_t
typedef atomic< intptr_t > | std::atomic_intptr_t
typedef atomic< long long > | std::atomic_llong
typedef atomic< long > | std::atomic_long
typedef atomic< ptrdiff_t > | std::atomic_ptrdiff_t
typedef atomic< signed char > | std::atomic_schar
typedef atomic< short > | std::atomic_short
typedef atomic< size_t > | std::atomic_size_t
typedef atomic< unsigned char > | std::atomic_uchar
typedef atomic< unsigned int > | std::atomic_uint
typedef atomic< uint16_t > | std::atomic_uint16_t
typedef atomic< uint32_t > | std::atomic_uint32_t
typedef atomic< uint64_t > | std::atomic_uint64_t
typedef atomic< uint8_t > | std::atomic_uint8_t
typedef atomic< uint_fast16_t > | std::atomic_uint_fast16_t
typedef atomic< uint_fast32_t > | std::atomic_uint_fast32_t
typedef atomic< uint_fast64_t > | std::atomic_uint_fast64_t
typedef atomic< uint_fast8_t > | std::atomic_uint_fast8_t
typedef atomic< uint_least16_t > | std::atomic_uint_least16_t
typedef atomic< uint_least32_t > | std::atomic_uint_least32_t
typedef atomic< uint_least64_t > | std::atomic_uint_least64_t
typedef atomic< uint_least8_t > | std::atomic_uint_least8_t
typedef atomic< uintmax_t > | std::atomic_uintmax_t
typedef atomic< uintptr_t > | std::atomic_uintptr_t
typedef atomic< unsigned long long > | std::atomic_ullong
typedef atomic< unsigned long > | std::atomic_ulong
typedef atomic< unsigned short > | std::atomic_ushort
typedef atomic< wchar_t > | std::atomic_wchar_t
typedef enum std::memory_order | std::memory_order

## Enumerations

enum | __memory_order_modifier { __memory_order_mask , __memory_order_modifier_mask , __memory_order_hle_acquire , __memory_order_hle_release }
enum | std::memory_order { memory_order_relaxed , memory_order_consume , memory_order_acquire , memory_order_release , memory_order_acq_rel , memory_order_seq_cst }

## Functions

constexpr memory_order | std::__cmpexch_failure_order (memory_order __m) noexcept
constexpr memory_order | std::__cmpexch_failure_order2 (memory_order __m) noexcept
constexpr bool | std::__is_valid_cmpexch_failure_order (memory_order __m) noexcept
template<typename _ITp>
bool | std::atomic_compare_exchange_strong (atomic< _ITp > *__a, __atomic_val_t< _ITp > *__i1, __atomic_val_t< _ITp > __i2) noexcept
template<typename _ITp>
bool | std::atomic_compare_exchange_strong (volatile atomic< _ITp > *__a, __atomic_val_t< _ITp > *__i1, __atomic_val_t< _ITp > __i2) noexcept
template<typename _ITp>
bool | std::atomic_compare_exchange_strong_explicit (atomic< _ITp > *__a, __atomic_val_t< _ITp > *__i1, __atomic_val_t< _ITp > __i2, memory_order __m1, memory_order __m2) noexcept
template<typename _ITp>
bool | std::atomic_compare_exchange_strong_explicit (volatile atomic< _ITp > *__a, __atomic_val_t< _ITp > *__i1, __atomic_val_t< _ITp > __i2, memory_order __m1, memory_order __m2) noexcept
template<typename _ITp>
bool | std::atomic_compare_exchange_weak (atomic< _ITp > *__a, __atomic_val_t< _ITp > *__i1, __atomic_val_t< _ITp > __i2) noexcept
template<typename _ITp>
bool | std::atomic_compare_exchange_weak (volatile atomic< _ITp > *__a, __atomic_val_t< _ITp > *__i1, __atomic_val_t< _ITp > __i2) noexcept
template<typename _ITp>
bool | std::atomic_compare_exchange_weak_explicit (atomic< _ITp > *__a, __atomic_val_t< _ITp > *__i1, __atomic_val_t< _ITp > __i2, memory_order __m1, memory_order __m2) noexcept
template<typename _ITp>
bool | std::atomic_compare_exchange_weak_explicit (volatile atomic< _ITp > *__a, __atomic_val_t< _ITp > *__i1, __atomic_val_t< _ITp > __i2, memory_order __m1, memory_order __m2) noexcept
template<typename _ITp>
_ITp | std::atomic_exchange (atomic< _ITp > *__a, __atomic_val_t< _ITp > __i) noexcept
template<typename _ITp>
_ITp | std::atomic_exchange (volatile atomic< _ITp > *__a, __atomic_val_t< _ITp > __i) noexcept
template<typename _ITp>
_ITp | std::atomic_exchange_explicit (atomic< _ITp > *__a, __atomic_val_t< _ITp > __i, memory_order __m) noexcept
template<typename _ITp>
_ITp | std::atomic_exchange_explicit (volatile atomic< _ITp > *__a, __atomic_val_t< _ITp > __i, memory_order __m) noexcept
template<typename _ITp>
_ITp | std::atomic_fetch_add (atomic< _ITp > *__a, __atomic_diff_t< _ITp > __i) noexcept
template<typename _ITp>
_ITp | std::atomic_fetch_add (volatile atomic< _ITp > *__a, __atomic_diff_t< _ITp > __i) noexcept
template<typename _ITp>
_ITp | std::atomic_fetch_add_explicit (atomic< _ITp > *__a, __atomic_diff_t< _ITp > __i, memory_order __m) noexcept
template<typename _ITp>
_ITp | std::atomic_fetch_add_explicit (volatile atomic< _ITp > *__a, __atomic_diff_t< _ITp > __i, memory_order __m) noexcept
template<typename _ITp>
_ITp | std::atomic_fetch_and (__atomic_base< _ITp > *__a, __atomic_val_t< _ITp > __i) noexcept
template<typename _ITp>
_ITp | std::atomic_fetch_and (volatile __atomic_base< _ITp > *__a, __atomic_val_t< _ITp > __i) noexcept
template<typename _ITp>
_ITp | std::atomic_fetch_and_explicit (__atomic_base< _ITp > *__a, __atomic_val_t< _ITp > __i, memory_order __m) noexcept
template<typename _ITp>
_ITp | std::atomic_fetch_and_explicit (volatile __atomic_base< _ITp > *__a, __atomic_val_t< _ITp > __i, memory_order __m) noexcept
template<typename _ITp>
_ITp | std::atomic_fetch_or (__atomic_base< _ITp > *__a, __atomic_val_t< _ITp > __i) noexcept
template<typename _ITp>
_ITp | std::atomic_fetch_or (volatile __atomic_base< _ITp > *__a, __atomic_val_t< _ITp > __i) noexcept
template<typename _ITp>
_ITp | std::atomic_fetch_or_explicit (__atomic_base< _ITp > *__a, __atomic_val_t< _ITp > __i, memory_order __m) noexcept
template<typename _ITp>
_ITp | std::atomic_fetch_or_explicit (volatile __atomic_base< _ITp > *__a, __atomic_val_t< _ITp > __i, memory_order __m) noexcept
template<typename _ITp>
_ITp | std::atomic_fetch_sub (atomic< _ITp > *__a, __atomic_diff_t< _ITp > __i) noexcept
template<typename _ITp>
_ITp | std::atomic_fetch_sub (volatile atomic< _ITp > *__a, __atomic_diff_t< _ITp > __i) noexcept
template<typename _ITp>
_ITp | std::atomic_fetch_sub_explicit (atomic< _ITp > *__a, __atomic_diff_t< _ITp > __i, memory_order __m) noexcept
template<typename _ITp>
_ITp | std::atomic_fetch_sub_explicit (volatile atomic< _ITp > *__a, __atomic_diff_t< _ITp > __i, memory_order __m) noexcept
template<typename _ITp>
_ITp | std::atomic_fetch_xor (__atomic_base< _ITp > *__a, __atomic_val_t< _ITp > __i) noexcept
template<typename _ITp>
_ITp | std::atomic_fetch_xor (volatile __atomic_base< _ITp > *__a, __atomic_val_t< _ITp > __i) noexcept
template<typename _ITp>
_ITp | std::atomic_fetch_xor_explicit (__atomic_base< _ITp > *__a, __atomic_val_t< _ITp > __i, memory_order __m) noexcept
template<typename _ITp>
_ITp | std::atomic_fetch_xor_explicit (volatile __atomic_base< _ITp > *__a, __atomic_val_t< _ITp > __i, memory_order __m) noexcept
void | std::atomic_flag_clear (atomic_flag *__a) noexcept
void | std::atomic_flag_clear (volatile atomic_flag *__a) noexcept
void | std::atomic_flag_clear_explicit (atomic_flag *__a, memory_order __m) noexcept
void | std::atomic_flag_clear_explicit (volatile atomic_flag *__a, memory_order __m) noexcept
bool | std::atomic_flag_test_and_set (atomic_flag *__a) noexcept
bool | std::atomic_flag_test_and_set (volatile atomic_flag *__a) noexcept
bool | std::atomic_flag_test_and_set_explicit (atomic_flag *__a, memory_order __m) noexcept
bool | std::atomic_flag_test_and_set_explicit (volatile atomic_flag *__a, memory_order __m) noexcept
template<typename _ITp>
void | std::atomic_init (atomic< _ITp > *__a, __atomic_val_t< _ITp > __i) noexcept
template<typename _ITp>
void | std::atomic_init (volatile atomic< _ITp > *__a, __atomic_val_t< _ITp > __i) noexcept
template<typename _ITp>
bool | std::atomic_is_lock_free (const atomic< _ITp > *__a) noexcept
template<typename _ITp>
bool | std::atomic_is_lock_free (const volatile atomic< _ITp > *__a) noexcept
template<typename _ITp>
_ITp | std::atomic_load (const atomic< _ITp > *__a) noexcept
template<typename _ITp>
_ITp | std::atomic_load (const volatile atomic< _ITp > *__a) noexcept
template<typename _ITp>
_ITp | std::atomic_load_explicit (const atomic< _ITp > *__a, memory_order __m) noexcept
template<typename _ITp>
_ITp | std::atomic_load_explicit (const volatile atomic< _ITp > *__a, memory_order __m) noexcept
void | std::atomic_signal_fence (memory_order __m) noexcept
template<typename _ITp>
void | std::atomic_store (atomic< _ITp > *__a, __atomic_val_t< _ITp > __i) noexcept
template<typename _ITp>
void | std::atomic_store (volatile atomic< _ITp > *__a, __atomic_val_t< _ITp > __i) noexcept
template<typename _ITp>
void | std::atomic_store_explicit (atomic< _ITp > *__a, __atomic_val_t< _ITp > __i, memory_order __m) noexcept
template<typename _ITp>
void | std::atomic_store_explicit (volatile atomic< _ITp > *__a, __atomic_val_t< _ITp > __i, memory_order __m) noexcept
void | std::atomic_thread_fence (memory_order __m) noexcept
template<typename _Tp>
_Tp | std::kill_dependency (_Tp __y) noexcept
constexpr memory_order | std::operator& (memory_order __m, __memory_order_modifier __mod)
constexpr memory_order | std::operator| (memory_order __m, __memory_order_modifier __mod)

## Detailed Description

Components for performing atomic operations.

## Macro Definition Documentation

## __cpp_lib_atomic_is_always_lock_free

#define __cpp_lib_atomic_is_always_lock_free

Definition at line 53 of file atomic.

## _GLIBCXX20_INIT [1/2]

#define _GLIBCXX20_INIT | ( |  | I | ) |

Definition at line 185 of file atomic.

## _GLIBCXX20_INIT [2/2]

#define _GLIBCXX20_INIT | ( |  | I | ) |

Definition at line 153 of file atomic_base.h.

## ATOMIC_BOOL_LOCK_FREE

#define ATOMIC_BOOL_LOCK_FREE

Lock-free property.

0 indicates that the types are never lock-free. 1 indicates that the types are sometimes lock-free. 2 indicates that the types are always lock-free.

Definition at line 49 of file atomic_lockfree_defines.h.

## ATOMIC_CHAR16_T_LOCK_FREE

#define ATOMIC_CHAR16_T_LOCK_FREE

Definition at line 55 of file atomic_lockfree_defines.h.

## ATOMIC_CHAR32_T_LOCK_FREE

#define ATOMIC_CHAR32_T_LOCK_FREE

Definition at line 56 of file atomic_lockfree_defines.h.

## ATOMIC_CHAR_LOCK_FREE

#define ATOMIC_CHAR_LOCK_FREE

Definition at line 50 of file atomic_lockfree_defines.h.

## ATOMIC_FLAG_INIT

#define ATOMIC_FLAG_INIT

Definition at line 193 of file atomic_base.h.

## ATOMIC_INT_LOCK_FREE

#define ATOMIC_INT_LOCK_FREE

Definition at line 58 of file atomic_lockfree_defines.h.

## ATOMIC_LLONG_LOCK_FREE

#define ATOMIC_LLONG_LOCK_FREE

Definition at line 60 of file atomic_lockfree_defines.h.

## ATOMIC_LONG_LOCK_FREE

#define ATOMIC_LONG_LOCK_FREE

Definition at line 59 of file atomic_lockfree_defines.h.

## ATOMIC_POINTER_LOCK_FREE

#define ATOMIC_POINTER_LOCK_FREE

Definition at line 61 of file atomic_lockfree_defines.h.

## ATOMIC_SHORT_LOCK_FREE

#define ATOMIC_SHORT_LOCK_FREE

Definition at line 57 of file atomic_lockfree_defines.h.

## ATOMIC_VAR_INIT

#define ATOMIC_VAR_INIT | ( |  | _VI | ) |

Definition at line 159 of file atomic_base.h.

## ATOMIC_WCHAR_T_LOCK_FREE

#define ATOMIC_WCHAR_T_LOCK_FREE

Definition at line 51 of file atomic_lockfree_defines.h.

## Typedef Documentation

## __atomic_flag_data_type

typedef unsigned char std::__atomic_flag_data_type

Definition at line 171 of file atomic_base.h.

## atomic_bool

typedef atomic<bool> std::atomic_bool

atomic_bool

Definition at line 1054 of file atomic.

## atomic_char

typedef atomic<char> std::atomic_char

atomic_char

Definition at line 1057 of file atomic.

## atomic_char16_t

typedef atomic<char16_t> std::atomic_char16_t

atomic_char16_t

Definition at line 1098 of file atomic.

## atomic_char32_t

typedef atomic<char32_t> std::atomic_char32_t

atomic_char32_t

Definition at line 1101 of file atomic.

## atomic_int

typedef atomic<int> std::atomic_int

atomic_int

Definition at line 1072 of file atomic.

## atomic_int16_t

typedef atomic<int16_t> std::atomic_int16_t

atomic_int16_t

Definition at line 1114 of file atomic.

## atomic_int32_t

typedef atomic<int32_t> std::atomic_int32_t

atomic_int32_t

Definition at line 1120 of file atomic.

## atomic_int64_t

typedef atomic<int64_t> std::atomic_int64_t

atomic_int64_t

Definition at line 1126 of file atomic.

## atomic_int8_t

typedef atomic<int8_t> std::atomic_int8_t

atomic_int8_t

Definition at line 1108 of file atomic.

## atomic_int_fast16_t

typedef atomic<int_fast16_t> std::atomic_int_fast16_t

atomic_int_fast16_t

Definition at line 1164 of file atomic.

## atomic_int_fast32_t

typedef atomic<int_fast32_t> std::atomic_int_fast32_t

atomic_int_fast32_t

Definition at line 1170 of file atomic.

## atomic_int_fast64_t

typedef atomic<int_fast64_t> std::atomic_int_fast64_t

atomic_int_fast64_t

Definition at line 1176 of file atomic.

## atomic_int_fast8_t

typedef atomic<int_fast8_t> std::atomic_int_fast8_t

atomic_int_fast8_t

Definition at line 1158 of file atomic.

## atomic_int_least16_t

typedef atomic<int_least16_t> std::atomic_int_least16_t

atomic_int_least16_t

Definition at line 1139 of file atomic.

## atomic_int_least32_t

typedef atomic<int_least32_t> std::atomic_int_least32_t

atomic_int_least32_t

Definition at line 1145 of file atomic.

## atomic_int_least64_t

typedef atomic<int_least64_t> std::atomic_int_least64_t

atomic_int_least64_t

Definition at line 1151 of file atomic.

## atomic_int_least8_t

typedef atomic<int_least8_t> std::atomic_int_least8_t

atomic_int_least8_t

Definition at line 1133 of file atomic.

## atomic_intmax_t

typedef atomic<intmax_t> std::atomic_intmax_t

atomic_intmax_t

Definition at line 1197 of file atomic.

## atomic_intptr_t

typedef atomic<intptr_t> std::atomic_intptr_t

atomic_intptr_t

Definition at line 1184 of file atomic.

## atomic_llong

typedef atomic<long long> std::atomic_llong

atomic_llong

Definition at line 1084 of file atomic.

## atomic_long

typedef atomic<long> std::atomic_long

atomic_long

Definition at line 1078 of file atomic.

## atomic_ptrdiff_t

typedef atomic<ptrdiff_t> std::atomic_ptrdiff_t

atomic_ptrdiff_t

Definition at line 1193 of file atomic.

## atomic_schar

typedef atomic<signed char> std::atomic_schar

atomic_schar

Definition at line 1060 of file atomic.

## atomic_short

typedef atomic<short> std::atomic_short

atomic_short

Definition at line 1066 of file atomic.

## atomic_size_t

typedef atomic<size_t> std::atomic_size_t

atomic_size_t

Definition at line 1190 of file atomic.

## atomic_uchar

typedef atomic<unsigned char> std::atomic_uchar

atomic_uchar

Definition at line 1063 of file atomic.

## atomic_uint

typedef atomic<unsigned int> std::atomic_uint

atomic_uint

Definition at line 1075 of file atomic.

## atomic_uint16_t

typedef atomic<uint16_t> std::atomic_uint16_t

atomic_uint16_t

Definition at line 1117 of file atomic.

## atomic_uint32_t

typedef atomic<uint32_t> std::atomic_uint32_t

atomic_uint32_t

Definition at line 1123 of file atomic.

## atomic_uint64_t

typedef atomic<uint64_t> std::atomic_uint64_t

atomic_uint64_t

Definition at line 1129 of file atomic.

## atomic_uint8_t

typedef atomic<uint8_t> std::atomic_uint8_t

atomic_uint8_t

Definition at line 1111 of file atomic.

## atomic_uint_fast16_t

typedef atomic<uint_fast16_t> std::atomic_uint_fast16_t

atomic_uint_fast16_t

Definition at line 1167 of file atomic.

## atomic_uint_fast32_t

typedef atomic<uint_fast32_t> std::atomic_uint_fast32_t

atomic_uint_fast32_t

Definition at line 1173 of file atomic.

## atomic_uint_fast64_t

typedef atomic<uint_fast64_t> std::atomic_uint_fast64_t

atomic_uint_fast64_t

Definition at line 1179 of file atomic.

## atomic_uint_fast8_t

typedef atomic<uint_fast8_t> std::atomic_uint_fast8_t

atomic_uint_fast8_t

Definition at line 1161 of file atomic.

## atomic_uint_least16_t

typedef atomic<uint_least16_t> std::atomic_uint_least16_t

atomic_uint_least16_t

Definition at line 1142 of file atomic.

## atomic_uint_least32_t

typedef atomic<uint_least32_t> std::atomic_uint_least32_t

atomic_uint_least32_t

Definition at line 1148 of file atomic.

## atomic_uint_least64_t

typedef atomic<uint_least64_t> std::atomic_uint_least64_t

atomic_uint_least64_t

Definition at line 1154 of file atomic.

## atomic_uint_least8_t

typedef atomic<uint_least8_t> std::atomic_uint_least8_t

atomic_uint_least8_t

Definition at line 1136 of file atomic.

## atomic_uintmax_t

typedef atomic<uintmax_t> std::atomic_uintmax_t

atomic_uintmax_t

Definition at line 1200 of file atomic.

## atomic_uintptr_t

typedef atomic<uintptr_t> std::atomic_uintptr_t

atomic_uintptr_t

Definition at line 1187 of file atomic.

## atomic_ullong

typedef atomic<unsigned long long> std::atomic_ullong

atomic_ullong

Definition at line 1087 of file atomic.

## atomic_ulong

typedef atomic<unsigned long> std::atomic_ulong

atomic_ulong

Definition at line 1081 of file atomic.

## atomic_ushort

typedef atomic<unsigned short> std::atomic_ushort

atomic_ushort

Definition at line 1069 of file atomic.

## atomic_wchar_t

typedef atomic<wchar_t> std::atomic_wchar_t

atomic_wchar_t

Definition at line 1090 of file atomic.

## memory_order

typedef enum std::memory_order std::memory_order

Enumeration for memory_order.

## Enumeration Type Documentation

## __memory_order_modifier

enum std::__memory_order_modifier

Definition at line 89 of file atomic_base.h.

## memory_order

enum std::memory_order

Enumeration for memory_order.

Definition at line 78 of file atomic_base.h.

## Function Documentation

## __cmpexch_failure_order()

memory_order std::__cmpexch_failure_order | ( | memory_order | __m | ) |

constexpr noexcept

Definition at line 118 of file atomic_base.h.

## __cmpexch_failure_order2()

memory_order std::__cmpexch_failure_order2 | ( | memory_order | __m | ) |

constexpr noexcept

Definition at line 111 of file atomic_base.h.

## __is_valid_cmpexch_failure_order()

bool std::__is_valid_cmpexch_failure_order | ( | memory_order | __m | ) |

constexpr noexcept

Definition at line 125 of file atomic_base.h.

## atomic_compare_exchange_strong() [1/2]

template<typename _ITp>

bool std::atomic_compare_exchange_strong | ( | atomic< _ITp > * | __a,
|  | __atomic_val_t< _ITp > * | __i1,
|  | __atomic_val_t< _ITp > | __i2 )

inline noexcept

Definition at line 1437 of file atomic.

## atomic_compare_exchange_strong() [2/2]

template<typename _ITp>

bool std::atomic_compare_exchange_strong | ( | volatile atomic< _ITp > * | __a,
|  | __atomic_val_t< _ITp > * | __i1,
|  | __atomic_val_t< _ITp > | __i2 )

inline noexcept

Definition at line 1448 of file atomic.

## atomic_compare_exchange_strong_explicit() [1/2]

template<typename _ITp>

bool std::atomic_compare_exchange_strong_explicit | ( | atomic< _ITp > * | __a,
|  | __atomic_val_t< _ITp > * | __i1,
|  | __atomic_val_t< _ITp > | __i2,
|  | memory_order | __m1,
|  | memory_order | __m2 )

inline noexcept

Definition at line 1365 of file atomic.

## atomic_compare_exchange_strong_explicit() [2/2]

template<typename _ITp>

bool std::atomic_compare_exchange_strong_explicit | ( | volatile atomic< _ITp > * | __a,
|  | __atomic_val_t< _ITp > * | __i1,
|  | __atomic_val_t< _ITp > | __i2,
|  | memory_order | __m1,
|  | memory_order | __m2 )

inline noexcept

Definition at line 1374 of file atomic.

## atomic_compare_exchange_weak() [1/2]

template<typename _ITp>

bool std::atomic_compare_exchange_weak | ( | atomic< _ITp > * | __a,
|  | __atomic_val_t< _ITp > * | __i1,
|  | __atomic_val_t< _ITp > | __i2 )

inline noexcept

Definition at line 1415 of file atomic.

## atomic_compare_exchange_weak() [2/2]

template<typename _ITp>

bool std::atomic_compare_exchange_weak | ( | volatile atomic< _ITp > * | __a,
|  | __atomic_val_t< _ITp > * | __i1,
|  | __atomic_val_t< _ITp > | __i2 )

inline noexcept

Definition at line 1426 of file atomic.

## atomic_compare_exchange_weak_explicit() [1/2]

template<typename _ITp>

bool std::atomic_compare_exchange_weak_explicit | ( | atomic< _ITp > * | __a,
|  | __atomic_val_t< _ITp > * | __i1,
|  | __atomic_val_t< _ITp > | __i2,
|  | memory_order | __m1,
|  | memory_order | __m2 )

inline noexcept

Definition at line 1347 of file atomic.

## atomic_compare_exchange_weak_explicit() [2/2]

template<typename _ITp>

bool std::atomic_compare_exchange_weak_explicit | ( | volatile atomic< _ITp > * | __a,
|  | __atomic_val_t< _ITp > * | __i1,
|  | __atomic_val_t< _ITp > | __i2,
|  | memory_order | __m1,
|  | memory_order | __m2 )

inline noexcept

Definition at line 1356 of file atomic.

## atomic_exchange() [1/2]

template<typename _ITp>

_ITp std::atomic_exchange | ( | atomic< _ITp > * | __a,
|  | __atomic_val_t< _ITp > | __i )

inline noexcept

Definition at line 1404 of file atomic.

## atomic_exchange() [2/2]

template<typename _ITp>

_ITp std::atomic_exchange | ( | volatile atomic< _ITp > * | __a,
|  | __atomic_val_t< _ITp > | __i )

inline noexcept

Definition at line 1409 of file atomic.

## atomic_exchange_explicit() [1/2]

template<typename _ITp>

_ITp std::atomic_exchange_explicit | ( | atomic< _ITp > * | __a,
|  | __atomic_val_t< _ITp > | __i,
|  | memory_order | __m )

inline noexcept

Definition at line 1334 of file atomic.

## atomic_exchange_explicit() [2/2]

template<typename _ITp>

_ITp std::atomic_exchange_explicit | ( | volatile atomic< _ITp > * | __a,
|  | __atomic_val_t< _ITp > | __i,
|  | memory_order | __m )

inline noexcept

Definition at line 1340 of file atomic.

## atomic_fetch_add() [1/2]

template<typename _ITp>

_ITp std::atomic_fetch_add | ( | atomic< _ITp > * | __a,
|  | __atomic_diff_t< _ITp > | __i )

inline noexcept

Definition at line 1559 of file atomic.

## atomic_fetch_add() [2/2]

template<typename _ITp>

_ITp std::atomic_fetch_add | ( | volatile atomic< _ITp > * | __a,
|  | __atomic_diff_t< _ITp > | __i )

inline noexcept

Definition at line 1565 of file atomic.

## atomic_fetch_add_explicit() [1/2]

template<typename _ITp>

_ITp std::atomic_fetch_add_explicit | ( | atomic< _ITp > * | __a,
|  | __atomic_diff_t< _ITp > | __i,
|  | memory_order | __m )

inline noexcept

Definition at line 1489 of file atomic.

## atomic_fetch_add_explicit() [2/2]

template<typename _ITp>

_ITp std::atomic_fetch_add_explicit | ( | volatile atomic< _ITp > * | __a,
|  | __atomic_diff_t< _ITp > | __i,
|  | memory_order | __m )

inline noexcept

Definition at line 1496 of file atomic.

## atomic_fetch_and() [1/2]

template<typename _ITp>

_ITp std::atomic_fetch_and | ( | __atomic_base< _ITp > * | __a,
|  | __atomic_val_t< _ITp > | __i )

inline noexcept

Definition at line 1583 of file atomic.

## atomic_fetch_and() [2/2]

template<typename _ITp>

_ITp std::atomic_fetch_and | ( | volatile __atomic_base< _ITp > * | __a,
|  | __atomic_val_t< _ITp > | __i )

inline noexcept

Definition at line 1589 of file atomic.

## atomic_fetch_and_explicit() [1/2]

template<typename _ITp>

_ITp std::atomic_fetch_and_explicit | ( | __atomic_base< _ITp > * | __a,
|  | __atomic_val_t< _ITp > | __i,
|  | memory_order | __m )

inline noexcept

Definition at line 1517 of file atomic.

## atomic_fetch_and_explicit() [2/2]

template<typename _ITp>

_ITp std::atomic_fetch_and_explicit | ( | volatile __atomic_base< _ITp > * | __a,
|  | __atomic_val_t< _ITp > | __i,
|  | memory_order | __m )

inline noexcept

Definition at line 1524 of file atomic.

## atomic_fetch_or() [1/2]

template<typename _ITp>

_ITp std::atomic_fetch_or | ( | __atomic_base< _ITp > * | __a,
|  | __atomic_val_t< _ITp > | __i )

inline noexcept

Definition at line 1595 of file atomic.

## atomic_fetch_or() [2/2]

template<typename _ITp>

_ITp std::atomic_fetch_or | ( | volatile __atomic_base< _ITp > * | __a,
|  | __atomic_val_t< _ITp > | __i )

inline noexcept

Definition at line 1601 of file atomic.

## atomic_fetch_or_explicit() [1/2]

template<typename _ITp>

_ITp std::atomic_fetch_or_explicit | ( | __atomic_base< _ITp > * | __a,
|  | __atomic_val_t< _ITp > | __i,
|  | memory_order | __m )

inline noexcept

Definition at line 1531 of file atomic.

## atomic_fetch_or_explicit() [2/2]

template<typename _ITp>

_ITp std::atomic_fetch_or_explicit | ( | volatile __atomic_base< _ITp > * | __a,
|  | __atomic_val_t< _ITp > | __i,
|  | memory_order | __m )

inline noexcept

Definition at line 1538 of file atomic.

## atomic_fetch_sub() [1/2]

template<typename _ITp>

_ITp std::atomic_fetch_sub | ( | atomic< _ITp > * | __a,
|  | __atomic_diff_t< _ITp > | __i )

inline noexcept

Definition at line 1571 of file atomic.

## atomic_fetch_sub() [2/2]

template<typename _ITp>

_ITp std::atomic_fetch_sub | ( | volatile atomic< _ITp > * | __a,
|  | __atomic_diff_t< _ITp > | __i )

inline noexcept

Definition at line 1577 of file atomic.

## atomic_fetch_sub_explicit() [1/2]

template<typename _ITp>

_ITp std::atomic_fetch_sub_explicit | ( | atomic< _ITp > * | __a,
|  | __atomic_diff_t< _ITp > | __i,
|  | memory_order | __m )

inline noexcept

Definition at line 1503 of file atomic.

## atomic_fetch_sub_explicit() [2/2]

template<typename _ITp>

_ITp std::atomic_fetch_sub_explicit | ( | volatile atomic< _ITp > * | __a,
|  | __atomic_diff_t< _ITp > | __i,
|  | memory_order | __m )

inline noexcept

Definition at line 1510 of file atomic.

## atomic_fetch_xor() [1/2]

template<typename _ITp>

_ITp std::atomic_fetch_xor | ( | __atomic_base< _ITp > * | __a,
|  | __atomic_val_t< _ITp > | __i )

inline noexcept

Definition at line 1607 of file atomic.

## atomic_fetch_xor() [2/2]

template<typename _ITp>

_ITp std::atomic_fetch_xor | ( | volatile __atomic_base< _ITp > * | __a,
|  | __atomic_val_t< _ITp > | __i )

inline noexcept

Definition at line 1613 of file atomic.

## atomic_fetch_xor_explicit() [1/2]

template<typename _ITp>

_ITp std::atomic_fetch_xor_explicit | ( | __atomic_base< _ITp > * | __a,
|  | __atomic_val_t< _ITp > | __i,
|  | memory_order | __m )

inline noexcept

Definition at line 1545 of file atomic.

## atomic_fetch_xor_explicit() [2/2]

template<typename _ITp>

_ITp std::atomic_fetch_xor_explicit | ( | volatile __atomic_base< _ITp > * | __a,
|  | __atomic_val_t< _ITp > | __i,
|  | memory_order | __m )

inline noexcept

Definition at line 1552 of file atomic.

## atomic_flag_clear() [1/2]

void std::atomic_flag_clear | ( | atomic_flag * | __a | ) |

inline noexcept

Definition at line 1252 of file atomic.

## atomic_flag_clear() [2/2]

void std::atomic_flag_clear | ( | volatile atomic_flag * | __a | ) |

inline noexcept

Definition at line 1256 of file atomic.

## atomic_flag_clear_explicit() [1/2]

void std::atomic_flag_clear_explicit | ( | atomic_flag * | __a,
|  | memory_order | __m )

inline noexcept

Definition at line 1235 of file atomic.

## atomic_flag_clear_explicit() [2/2]

void std::atomic_flag_clear_explicit | ( | volatile atomic_flag * | __a,
|  | memory_order | __m )

inline noexcept

Definition at line 1239 of file atomic.

## atomic_flag_test_and_set() [1/2]

bool std::atomic_flag_test_and_set | ( | atomic_flag * | __a | ) |

inline noexcept

Definition at line 1244 of file atomic.

## atomic_flag_test_and_set() [2/2]

bool std::atomic_flag_test_and_set | ( | volatile atomic_flag * | __a | ) |

inline noexcept

Definition at line 1248 of file atomic.

## atomic_flag_test_and_set_explicit() [1/2]

bool std::atomic_flag_test_and_set_explicit | ( | atomic_flag * | __a,
|  | memory_order | __m )

inline noexcept

Definition at line 1205 of file atomic.

## atomic_flag_test_and_set_explicit() [2/2]

bool std::atomic_flag_test_and_set_explicit | ( | volatile atomic_flag * | __a,
|  | memory_order | __m )

inline noexcept

Definition at line 1210 of file atomic.

## atomic_init() [1/2]

template<typename _ITp>

void std::atomic_init | ( | atomic< _ITp > * | __a,
|  | __atomic_val_t< _ITp > | __i )

inline noexcept

Definition at line 1301 of file atomic.

## atomic_init() [2/2]

template<typename _ITp>

void std::atomic_init | ( | volatile atomic< _ITp > * | __a,
|  | __atomic_val_t< _ITp > | __i )

inline noexcept

Definition at line 1306 of file atomic.

## atomic_is_lock_free() [1/2]

template<typename _ITp>

bool std::atomic_is_lock_free | ( | const atomic< _ITp > * | __a | ) |

inline noexcept

Definition at line 1291 of file atomic.

## atomic_is_lock_free() [2/2]

template<typename _ITp>

bool std::atomic_is_lock_free | ( | const volatile atomic< _ITp > * | __a | ) |

inline noexcept

Definition at line 1296 of file atomic.

## atomic_load() [1/2]

template<typename _ITp>

_ITp std::atomic_load | ( | const atomic< _ITp > * | __a | ) |

inline noexcept

Definition at line 1394 of file atomic.

## atomic_load() [2/2]

template<typename _ITp>

_ITp std::atomic_load | ( | const volatile atomic< _ITp > * | __a | ) |

inline noexcept

Definition at line 1399 of file atomic.

## atomic_load_explicit() [1/2]

template<typename _ITp>

_ITp std::atomic_load_explicit | ( | const atomic< _ITp > * | __a,
|  | memory_order | __m )

inline noexcept

Definition at line 1323 of file atomic.

## atomic_load_explicit() [2/2]

template<typename _ITp>

_ITp std::atomic_load_explicit | ( | const volatile atomic< _ITp > * | __a,
|  | memory_order | __m )

inline noexcept

Definition at line 1328 of file atomic.

## atomic_signal_fence()

void std::atomic_signal_fence | ( | memory_order | __m | ) |

inline noexcept

Definition at line 136 of file atomic_base.h.

## atomic_store() [1/2]

template<typename _ITp>

void std::atomic_store | ( | atomic< _ITp > * | __a,
|  | __atomic_val_t< _ITp > | __i )

inline noexcept

Definition at line 1384 of file atomic.

## atomic_store() [2/2]

template<typename _ITp>

void std::atomic_store | ( | volatile atomic< _ITp > * | __a,
|  | __atomic_val_t< _ITp > | __i )

inline noexcept

Definition at line 1389 of file atomic.

## atomic_store_explicit() [1/2]

template<typename _ITp>

void std::atomic_store_explicit | ( | atomic< _ITp > * | __a,
|  | __atomic_val_t< _ITp > | __i,
|  | memory_order | __m )

inline noexcept

Definition at line 1311 of file atomic.

## atomic_store_explicit() [2/2]

template<typename _ITp>

void std::atomic_store_explicit | ( | volatile atomic< _ITp > * | __a,
|  | __atomic_val_t< _ITp > | __i,
|  | memory_order | __m )

inline noexcept

Definition at line 1317 of file atomic.

## atomic_thread_fence()

void std::atomic_thread_fence | ( | memory_order | __m | ) |

inline noexcept

Definition at line 132 of file atomic_base.h.

## kill_dependency()

template<typename _Tp>

_Tp std::kill_dependency | ( | _Tp | __y | ) |

inline noexcept

kill_dependency

Definition at line 142 of file atomic_base.h.

## operator&()

memory_order std::operator& | ( | memory_order | __m,
|  | __memory_order_modifier | __mod )

constexpr

Definition at line 104 of file atomic_base.h.

## operator|()

memory_order std::operator| | ( | memory_order | __m,
|  | __memory_order_modifier | __mod )

constexpr

Definition at line 98 of file atomic_base.h.